Imports System.Text
Imports System.IO

Public Class AttentionTrial
    Inherits ExpTrial
    Dim ED As ExpDisp
    Dim ES As New ExpSettings
    Dim ET As New ExpTimingAndResponses

    '' Response parameters
    Public subjectResponse As Boolean
    Public subjectCorrect As Boolean
    Public subjectRT As Object

    Public MinRT = 100
    Public MaxRT = frmStart.RespInt
    Public adaptive As Integer
    Public TargetColor As Integer
    Public TargetVisible As Integer
    Public cX, cY, XYdist As Integer
    Public XYboo As Boolean

    Public inputPar(frmStart.numSectors - 1) As Double
    Public filteredPar(frmStart.numSectors - 1) As Double

    Shadows ParentTrialList As AttentionTrialList

    Sub New(ByVal aTrialList)
        MyBase.New(aTrialList)
        ParentTrialList = aTrialList
    End Sub

    Overrides Sub Run(ByVal trialI)
        Dim trialStart As Double
        Dim targetTime As Object

        Dim velMod As Double
        Dim posMod As Double
        '' Debug info about how many times the parameters have "crashed" against their boundaries
        Dim WallBump As Integer

        Dim subscript

        '' FOR DEBUGGING PURPOSES ONLY -- DO NOT UNCOMMENT!
        'MemInt = 0
        'RespInt = 0
        'ITI = 0
        'StillInt = 0

        Dim TargetVar As Integer = ParamValues("Target")
        Dim TargetPos = ParamValues("Target_Pos")

        Dim Letters As String
        If TargetPos = "N/A" Then
            Letters = Letterselection(frmStart.LetterNum, frmStart.LetterNum)
        Else
            Letters = Letterselection(frmStart.LetterNum, TargetPos)
        End If

        AddParameter("Letters", Letters)

        ED = ParentTrialList.ExperimentalDisplay

        '' Decide zero-th timepoing, which will later become the probe point
        Dim TP As Integer = 0
        For sector As Integer = 0 To frmStart.numSectors - 1
            For parNum As Integer = 0 To frmStart.parNum - 1
                For factor As Integer = 0 To 2
                    frmStart.sectorPars(trialI, TP, sector, parNum, factor) = Rnd()
                Next
            Next

            '' DOES THIS CHANGE IN REAL TIME OR TRIAL TO TRIAL?
            If frmStart.Adaptive = 1 Then
                '' Here we can set the alpha of the stimuli!

                inputPar(sector) = frmStart.RTcomms.GetParameter(0)

                filteredPar(sector) = ParameterPsy(inputPar(sector))
                frmStart.alpha(sector) = Math.Round(2 ^ filteredPar(sector))
                'adaptive = GetFileContents(Application.StartupPath & "/adaptive.txt")
                'frmStart.alpha(sector) = adaptive

            ElseIf frmStart.Adaptive = 0 Then
                Dim AlphaVar As Integer = ParamValues("Contrast")
                '' Here we can set the alpha of the stimuli!
                '' Take the constant value that the program decides trial by trial
                '' THIS USES AN EXPONENTIAL FUNCTION TO DECIDE CONTRAST
                inputPar(sector) = AlphaVar
                filteredPar(sector) = ParameterPsy(inputPar(sector))
                frmStart.alpha(sector) = Math.Round(2 ^ filteredPar(sector))
            End If

            '' Use if each sector has a different contrast
            'AddParameter("InputPar_" & sector, inputPar(sector))
            'AddParameter("FilteredPar_" & sector, filteredPar(sector))
            'AddParameter("Alpha_" & sector, frmStart.alpha(sector))
        Next

        AddParameter("InputPar", inputPar(0))
        AddParameter("FilteredPar", filteredPar(0))
        AddParameter("Alpha", frmStart.alpha(0))

        ' Send the original *parameter* back to the realtime and the actual *parameter* and contrast

        frmStart.RTcomms.SendParameter("Trial", "Number " & trialI & " inputParameter " & inputPar(0) & " filteredParameter " & filteredPar(0) & " Contrast " & frmStart.alpha(0))

        
        trialStart = ET.GetTimer
        AddParameter("TrialStartTime", trialStart)

        If TargetPos = "N/A" Then
            targetTime = "N/A"
        Else
            targetTime = trialStart + TargetPos * frmStart.RespInt
        End If
        AddParameter("TargetStartTime", targetTime)

        '' WE NEED TO MODIFY THE FOLLOWING TO OPTIMISE THE CHANGING PARAMETERS
        For TP = 1 To Int(60 * (frmStart.StillInt) / 1000)
            '' Modify each sector fluently, by randomising the acceleration of parameter change
            For sector As Integer = 0 To frmStart.numSectors - 1
                For parNum As Integer = 0 To frmStart.parNum - 1
                    posMod = frmStart.Par(parNum, 1) * (2 * frmStart.sectorPars(trialI, TP - 1, sector, parNum, 0) - 1) ^ frmStart.posBoundPower
                    velMod = frmStart.sectorPars(trialI, TP - 1, sector, parNum, 1) ^ frmStart.velBoundPower

                    '' Essentially acceleration equals (2 * Rnd() - 1)
                    '' However it is modified by velocity, which is bounded depending on size
                    '' and in bounded parameters only, it also depends on parameter value (depending on a power function)
                    frmStart.sectorPars(trialI, TP, sector, parNum, 2) = (2 - (frmStart.posBoundForce * posMod + frmStart.velBoundForce * velMod)) * Rnd() - 1
                    frmStart.sectorPars(trialI, TP, sector, parNum, 1) = frmStart.sectorPars(trialI, TP - 1, sector, parNum, 1) + frmStart.accK * frmStart.sectorPars(trialI, TP - 1, sector, parNum, 2)


                    frmStart.sectorPars(trialI, TP, sector, parNum, 0) = frmStart.sectorPars(trialI, TP - 1, sector, parNum, 0) + frmStart.velK * frmStart.sectorPars(trialI, TP - 1, sector, parNum, 1)

                    If frmStart.sectorPars(trialI, TP, sector, parNum, 0) < 0 Then
                        If frmStart.Par(parNum, 1) = 0 Then
                            frmStart.sectorPars(trialI, TP, sector, parNum, 0) += 1
                        ElseIf frmStart.Par(parNum, 1) = 1 Then
                            WallBump += 1
                            frmStart.sectorPars(trialI, TP, sector, parNum, 0) = -frmStart.sectorPars(trialI, TP, sector, parNum, 0)
                        End If
                    ElseIf frmStart.sectorPars(trialI, TP, sector, parNum, 0) > 1 Then
                        If frmStart.Par(parNum, 1) = 0 Then
                            frmStart.sectorPars(trialI, TP, sector, parNum, 0) -= 1
                        ElseIf frmStart.Par(parNum, 1) = 1 Then
                            WallBump += 1
                            frmStart.sectorPars(trialI, TP, sector, parNum, 0) = 2 - frmStart.sectorPars(trialI, TP, sector, parNum, 0)
                        End If
                    End If

                    '' Recorded averaged
                    frmStart.sectorAvgs(trialI, sector, parNum) += frmStart.sectorPars(trialI, TP, sector, parNum, 0)
                Next
            Next

            'Make each frame appear at regular intervals
            ParentTrialList.ET.WaitForTime(trialStart + TP * (1000 / 60), Responses)

            subscript = Math.Round((ET.GetTimer - trialStart) / frmStart.RespInt - 0.5)

            ED.RenderSectors(trialI, frmStart.sectorPars, TP, frmStart.alpha, Letters(subscript))
        Next

        AddParameter("DelayStartTime", ET.GetTimer)

        For d As Integer = 1 To Math.Round((frmStart.DelayInt) / frmStart.RespInt)
            subscript = Math.Round((frmStart.StillInt) / frmStart.RespInt) + d - 1
            Math.Round((ET.GetTimer - trialStart) / frmStart.RespInt - 0.5)

            ED.D3Device.BeginScene()
            ED.ClearScreen()
            ED.DrawFixation(Letters(subscript))
            ED.D3Device.EndScene()
            ED.D3Device.Present()

            ParentTrialList.ET.WaitForTime(trialStart + frmStart.StillInt + d / Math.Round((frmStart.DelayInt) / frmStart.RespInt) * frmStart.DelayInt, Responses)
        Next

        ResponseAcquisition(trialStart, targetTime, trialI, TargetVar, WallBump)

        AddParameter("TrialEnd", ET.GetTimer)

        ''  The following is useful for MRI experiments
        Dim MeasuredTR, LastPulseNum, LastPulseTIme
        ParentTrialList.ET.LogScannerStuff(MeasuredTR, LastPulseNum, LastPulseTIme)
        AddParameter("GetMeasuredTR", MeasuredTR)
        AddParameter("GetLastPulseNum", LastPulseNum)
        AddParameter("GetLastPulseTime", LastPulseTIme)
    End Sub
    Public Sub ResponseAcquisition(ByVal trialStart, ByVal TargetTime, ByVal trialI, ByVal TargetVar, ByVal WallBump)
        Dim ButtonBoxCode, RespCorrCode As Integer
        Dim RespSide As String

        '' Firstly assume that we have no responses...
        subjectResponse = False
        ButtonBoxCode = 30 '' Equivalent to no key press in the ButtonBox
        RespSide = "N/A"
        subjectRT = "N/A"

        If Responses.Count > 0 Then
            Dim Myresp As AResponse = Responses(1)
            subjectResponse = True
            ButtonBoxCode = Myresp.KeyCode

            If Myresp.KeyCode = 26 Or Myresp.KeyCode = 0 Then
                Myresp.KeyCode = 0
                RespSide = "R"
            ElseIf Myresp.KeyCode = 28 Or Myresp.KeyCode = 1 Then
                Myresp.KeyCode = 1
                RespSide = "L"
            Else
                RespSide = "N/A"
            End If

            If TargetVar = 0 Then
                '' If there was no Target, record the time relative to the start of a trial
                subjectRT = Myresp.ResponseTime - trialStart
                subjectCorrect = False
            Else
                '' If there was a Target, record the time taken relative to the stop
                subjectRT = Myresp.ResponseTime - TargetTime

                If subjectRT > MinRT And subjectRT < MaxRT Then
                    subjectCorrect = True
                Else
                    subjectCorrect = False
                End If
            End If
        Else
            If TargetVar = 0 Then
                subjectCorrect = True
            Else
                subjectCorrect = False
            End If
        End If

        AddParameter("ResponseEnd", ET.GetTimer)
        AddParameter("RT", subjectRT)
        AddParameter("Responded?", subjectResponse)
        AddParameter("Correct?", subjectCorrect)
        AddParameter("Response-side", RespSide)
        AddParameter("Buttonbox-code", ButtonBoxCode)

        '' RECORD THE FIRST & LAST PERMUTATIONS OF THE PRIME & THE PROBE
        For sector As Integer = 0 To frmStart.numSectors - 1
            For parNum As Integer = 0 To frmStart.parNum - 1
                AddParameter("1st_Prime_Sect-" & (sector + 1) & "_Par-" & parNum, frmStart.sectorPars(trialI, 1, sector, parNum, 0))
                AddParameter("Avg_Prime_Sect-" & (sector + 1) & "_Par-" & parNum, frmStart.sectorAvgs(trialI, sector, parNum) / Int(60 * frmStart.StillInt / 1000))
                AddParameter("Last_Prime_Sect-" & (sector + 1) & "_Par-" & parNum, frmStart.sectorPars(trialI, Int(60 * frmStart.StillInt / 1000), sector, parNum, 0))
            Next
        Next

        AddParameter("WallBumps", WallBump)
    End Sub

    Public Function GetFileContents(ByVal FullPath As String, _
   Optional ByRef ErrInfo As String = "") As String
        Dim strContents As String
        Dim objReader As StreamReader
        Dim fs As New FileStream(FullPath, FileMode.Open, FileAccess.Read, FileShare.ReadWrite)
        objReader = New StreamReader(fs)
        Do
            strContents = objReader.ReadLine()
        Loop Until (objReader.EndOfStream)
        objReader.Close()
        Return strContents

    End Function

    Public Function ParameterPsy(ByVal p)
        Dim Y As Double

        Y = frmStart.MinPsy + (frmStart.Range / (1 + Math.Exp(-(p - frmStart.Threshold) / frmStart.Slope)))

        Return Y
    End Function

    Public Function Letterselection(ByVal letterNum, ByVal targetPos)
        Dim mystr As String
        Dim myoutput As String
        Dim mypos(letterNum - 1) As Integer
        Dim temp As String

        mystr = "BCDFGHJKLNPQRSTVYZ"
        myoutput = ""
        'T'wo strings of letters, master and 'slave' string

        For j As Integer = 0 To letterNum - 1
            If j = targetPos Then
                myoutput = myoutput & "X"
            Else
                Do
                    mypos(j) = 1 + Int(Rnd() * Len(mystr))
                    temp = Mid(mystr, mypos(j), 1)
                Loop Until InStr(myoutput, temp, CompareMethod.Text) = 0
                myoutput = myoutput & temp
            End If
        Next

        ''Randomises the selection of letters from the string, do not allow repeats
        Letterselection = myoutput

        ''The following will display letterstrings
        'System.Diagnostics.Debug.WriteLine(Letterselection2)
    End Function
End Class
